﻿PCLoader = function (manager) {

    THREE.Loader.call(this, manager);

};

PCLoader.prototype = Object.assign(Object.create(THREE.Loader.prototype), {

    constructor: PCLoader,

    load: function (url, onLoad, onProgress, onError) {
        var scope = this;

        var loader = new THREE.FileLoader(scope.manager);
        loader.setPath(this.path);
        loader.setResponseType('arraybuffer');
        loader.load(url, function (data) {
            onLoad(scope.parse(data));
        }, onProgress, onError);
    },

    setPath: function (value) {
        this.path = value;
        return this;
    },

    parse: function (data) {
        var geometry = new THREE.BufferGeometry();
        geometry.addAttribute('position', new THREE.BufferAttribute(new Float32Array(data, 0, data.byteLength / 8), 3));
        geometry.addAttribute('color', new THREE.BufferAttribute(new Float32Array(data, data.byteLength / 2, data.byteLength / 8), 3));
        geometry.computeBoundingSphere();

        var material = new THREE.PointsMaterial();
        material.vertexColors = THREE.VertexColors;
        material.size = 2.7;
        material.sizeAttenuation = false;

        return new THREE.Points(geometry, material);
    }
});
